from kernel32.dll

voc: kernel32
kernel32
   variable buffer
   1 import CloseHandle
   3 import OpenFile
   5 import ReadFile
   5 import WriteFile
   1 import SetConsoleTitleA
   1 import GetStdHandle
   1 import GetModuleHandleA
   2 import SetConsoleMode
   1 import ExitProcess
   2 import SetConsoleCursorPosition
   0 import GetCommandLineA
 -11 GetStdHandle constant stdout
 -10 GetStdHandle constant stdin
^

here default: bye  ] kernel32 0 ExitProcess ^ ;
here default: emit ] kernel32 buffer c! stdout buffer 1 buffer cell+ 0 WriteFile drop ^ ;
here default: type ] kernel32 >r >r stdout r> r> buffer 0 WriteFile drop ^ ;
here default: key  ] kernel32 stdin buffer 1 buffer cell+ 0 ReadFile drop buffer c@ ^ ;

: choose vector ;
: use vector wsparse choose ;
: reload vector ;
: save vector ;

loc:
  create fname 256 allot
  : erase fname 256 0 fill ;
  here is choose ] erase fname swap move ;

  : size #-of-blocks 512 * ;

  variable current
  : close current @ kernel32 CloseHandle ^ drop ;

  $0002 constant read-mode
  $1002 constant write-mode

   : open >r fname here r> kernel32 OpenFile ^ current ! ;

  here is reload ]
     read-mode  open current @ there size here 0 kernel32 ReadFile ^ drop ; 
  here is save ]
     write-mode open current @ there size here 0 kernel32 WriteFile ^ drop ; 
;loc

: load new use reload ;
: -f load \f ;

loc:
 : adjust @b0 64 512 * - 1024 - b0 ! 64 !<#blocks> ;
 here ] @b0 >r @<#blocks> >r adjust new -f r> !<#blocks> r> !b0 ;
;loc is include

loc:
  : home kernel32 stdout 0 SetConsoleCursorPosition drop ^ ;
 here default: clear ] home 90 60 * for 32 emit next home ;
;loc

loc:
  : obtain >in @ 0 import last @ :xt @ 5 + @ swap >in ! ;
  : mark last @ here ;
  : revert h0 ! last ! ;
  : finalize imported? if constant ;then drop wsparse 2drop ;
  here ] mark >r >r obtain r> r> revert finalize ;
;loc is import-var

create: callback
  $52515358 , $89555657 , $40ec83e6 , $00000ae8 , $40c48300 ,
  $5a5f5e5d , $ffc35b59 , $e0 1,


: cmdline kernel32 GetCommandLineA ^ ;

loc:
  : skip-byte >r dup c@ r> =if 1+ true rdrop then ;
  : null? dup c@ 0 =if drop false rdrop then ;
  : to-filename repeat 32 skip-byte null? 1+ again ;
  : get-length repeat dup c@ 0 =if ;then 1+ again ;
  here ] cmdline 1+ to-filename if dup get-length over - eval then ;
;loc execute
